<?php
////////////////////////////////////////////////////////////////////////////////////////////////////
//
//		File:
//			settings.php
//		Description:
//			This file compiles and processes the plugin's various settings pages.
//		Actions:
//			1) compile overall plugin settings form
//			2) process and save plugin settings
//		Date:
//			Added on November 3rd 2010
//		Copyright:
//			Copyright (c) 2010 Matthew Praetzel.
//		License:
//			This software is licensed under the terms of the GNU General Public License v3
//			as published by the Free Software Foundation. You should have received a copy of of
//			the GNU General Public License along with this software. In the event that you
//			have not, please visit: http://www.gnu.org/licenses/gpl-3.0.txt
//
////////////////////////////////////////////////////////////////////////////////////////////////////

/****************************************Commence Script*******************************************/

//                                *******************************                                 //
//________________________________** INITIALIZE VARIABLES      **_________________________________//
//////////////////////////////////**                           **///////////////////////////////////
//                                **                           **                                 //
//                                *******************************                                 //
$tern_wp_youtube_vids = array();
$tern_wp_youtube_index = 0;
ini_set(max_execution_time,600);
//ini_set('memory_limit','40M');
//                                *******************************                                 //
//________________________________** ADD EVENTS                **_________________________________//
//////////////////////////////////**                           **///////////////////////////////////
//                                **                           **                                 //
//                                *******************************                                 //
add_action('init','WP_ayvpp_add_posts');
//                                *******************************                                 //
//________________________________** POST FUNCTIONS            **_________________________________//
//////////////////////////////////**                           **///////////////////////////////////
//                                **                           **                                 //
//                                *******************************                                 //
function WP_ayvpp_add_posts($x=1,$n=20) {
	global $getWP,$getFIX,$tern_wp_youtube_options,$tern_wp_youtube_vids,$getFILE,$tern_wp_youtube_index;
	$o = $getWP->getOption('tern_wp_youtube',$tern_wp_youtube_options);
	$videos = $getWP->getOption('tern_wp_youtube_videos',array());
	$videos = empty($videos) ? array() : $videos;
	
	if(($o['last_import']+($o['cron']*3600)) > time() and !empty($o['last_import']) and $n != '*') {
		return;
	}
	
	$x = empty($x) ? 1 : (int)$x;
	$tern_wp_youtube_index = $x;
	
	if(empty($o['user']) or !$o['category'] or empty($o['category']) or $o['category'] == '-1') {
		return;
	}
	$u = explode(',',$o['user']);
	$u = $getFIX->removeEmptyValues($u,false);
	
	foreach($u as $v) {
		
		$tern_wp_youtube_vids = array();
		WP_ayvpp_parse_videos($v,$x,$n);

		if(empty($tern_wp_youtube_vids)) {
			return false;
		}
		
		$c = 0;
		
		foreach((array)$tern_wp_youtube_vids as $v) {
		
			$v = $v['value'] ? $v['value'] : $v;
		
			$i = explode('/',$v['id']);
			$i = $i[count($i)-1];
			$k = array_keys($videos);
			$j = is_array($o['videos']) ? array_keys($o['videos']) : array();
			
			if(!in_array($i,$k) and !in_array($i,$j)) {
				$s = !empty($v['content']['value']) ? $v['content']['value'] : '';
				if(empty($s)) {
					$s = !empty($v['media:description']['value']) ? $v['media:description']['value'] : '';
				}
				//$s = preg_replace("/[\r\n]+/",'<br />',$s);
				$s = explode(' ',$s);
				
				if($o['words'] and count($s) > $o['words']) {
					$s = array_merge(array_splice($s,0,$o['words']),array('<!--more-->'),$s);
				}
				
				$s = implode(' ',$s);
				$w = isset($v['media:group']['media:keywords']) ? $v['media:group']['media:keywords'] : '';
				
				$a = array(
					'action'						=>	'post',
					'type'							=>	'post',
					'post_title'					=>	$v['title']['value'],
					'post_content'					=>	$s,
					'post_category'					=>	array($o['category']),
					'post_status'					=>	'publish',
					'comment_status'				=>	'open',
					'ping_status'					=>	'open',
					'_tern_wp_youtube_video'		=>	$i,
					'_tern_wp_youtube_published'	=>	strtotime($v['published']),
					'_tern_wp_youtube_author'		=>	$v['author']['name'],
					'post_status'					=>	$o['publish'] ? 'publish' : 'draft',
					'tags_input'					=>	$w,
					'post_date'						=>	gmdate('Y-m-d H:i:s',strtotime($v['published']))
				);
				
				$a['id'] = WP_ayvpp_insert_post($a);
				
				if($a['id']) {
					$c = $getFILE->contents(WP_CONTENT_DIR.'/cache/ayvpp.txt');
					$c .= empty($c) ? $v['title']['value'] : '<->'.$v['title']['value'];
					$getFILE->createFile('ayvpp.txt',$c,WP_CONTENT_DIR.'/cache');
					//$o['videos'][$i] = $a;
					$videos[$i] = $a['id'];
					$getWP->getOption('tern_wp_youtube_videos',$videos,true);
				}
			}
			elseif(!in_array($i,$k) and in_array($i,$j)) {
				$videos[$i] = $o['videos'][$i]['id'];
				$getWP->getOption('tern_wp_youtube_videos',$videos,true);
			}
			$c++;
		}
		
	}
	//$o = $getWP->getOption('tern_wp_youtube',$o,true);
	
	unset($u,$tern_wp_youtube_vids,$s,$w,$a,$c);
	
	if($n == '*') {
		WP_ayvpp_add_posts($x+50,$n);
	}
	else {
		$o['last_import'] = time();
		$o = $getWP->getOption('tern_wp_youtube',$o,true);
	}
	
}
function WP_ayvpp_insert_post($a) {
	global $tern_wp_youtube_array;
	$tern_wp_youtube_array = $a;
	add_action('wp_insert_post','WP_ayvpp_add_meta');
	$p = wp_insert_post($a);
	//WP_ayvpp_twitter_status($p);
	return $p;
}
function WP_ayvpp_delete_posts($i) {
	global $getWP,$tern_wp_youtube_options,$tern_wp_youtube_fields;
	$o = $getWP->getOption('tern_wp_youtube',$tern_wp_youtube_options);
	$videos = $getWP->getOption('tern_wp_youtube_videos',array());
	$y = get_post_meta($i,'_tern_wp_youtube_video',true);
	if($videos[$y]) {
		$videos[$y] = false;
		foreach($tern_wp_youtube_fields as $v) {
			delete_post_meta($i,$v);
		}
	}
}
function WP_ayvpp_add_meta($i) {
	global $tern_wp_youtube_fields,$tern_wp_youtube_array;
	foreach($tern_wp_youtube_fields as $v) {
		if(!empty($tern_wp_youtube_array[$v]) or !empty($_POST[$v])) {
			$m = empty($tern_wp_youtube_array[$v]) ? $_POST[$v] : $tern_wp_youtube_array[$v];
			update_post_meta($i,$v,$m);
		}
		else {
			delete_post_meta($i,$v);
		}
	}
}
function WP_ayvpp_parse_videos($v,$i=1,$n=20) {
	global $tern_wp_youtube_vids,$tern_wp_youtube_index;

	$z = $n == '*' ? 50 : $n;
	
	$c = new tern_curl();
	$r = $c->get(array(
		'url'		=>	'http://gdata.youtube.com/feeds/api/users/'.$v.'/uploads?orderby=published&max-results='.$z.'&start-index='.$i,
		'options'	=>	array(
			'RETURNTRANSFER'	=>	true,
			'FOLLOWLOCATION'	=>	true
		)
	));
	
	$x = new ternXML;
	$a = $x->parse($r->body);
	
	if(empty($a['feed']['value']['entry'])) {
		return;
	}
	else {
		$a = $a['feed']['value']['entry'];
	}
	
	if($a['id']) { 
		$a = array($a);
	}
	
	$tern_wp_youtube_vids = array_merge($tern_wp_youtube_vids,$a);
	
	unset($c,$r,$x,$a);
	
}
//                                *******************************                                 //
//________________________________** SOCIAL                    **_________________________________//
//////////////////////////////////**                           **///////////////////////////////////
//                                **                           **                                 //
//                                *******************************                                 //

//Twitter changed to OATH. For now the twitter features are no longer available.
/*
function WP_ayvpp_twitter_status($i) {
	global $getWP,$tern_wp_youtube_options;
	$o = $getWP->getOption('tern_wp_youtube',$tern_wp_youtube_options);
	
	if(empty($o['twitter_text'])) {
		$o['twitter_text'] = $tern_wp_youtube_options['twitter_text'];
	}
	
	if($o['twitter'] and !empty($o['twitter_user']) and !empty($o['twitter_password'])) {
		$t = new MyTwitter($o['twitter_user'],$o['twitter_password']);
		if($t) {
			$t->updateStatus(str_replace('%twitter_link%',get_permalink($i),$o['twitter_text']));var_dump($t);die();
		}
	}
}
*/

/****************************************Terminate Script******************************************/
?>